# DNS Manager GUI
In deze folder bevind zich alle code omtrent de web-gui voor de DNS manager.

## Install
### Container
Als je direct de container gebruikt moet je de environment variables gebruiken die op de docker page staat
https://hub.docker.com/r/4grxfq/gui/ vergeet ook poort 5000 niet te openen naar je container

### Manual install
1. verander de variabelen in gui.py die aangepast moeten worden of zet de environment variabelen in je shell
2. run ```pip install -r /app/requirements.txt```
3. start flask ```python3 gui.py``` de webserver luistert naar poort 5000


## Screenshots
### Index page
Op de index page wordt er een inlog form getoont, ook worden hyperlinks getoont naar de dashboard voor als je al
ingelogt bent, en een link naar de uitlog pad. De username en password textvakken doen niets en zijn puur cosmetisch,,
je kunt alleen inloggen met de klop die je redirect naar de google OID login pagina.

![login page](.assets/login.png)

### Dashboard page
De dashboard page laat een basale tabel zien met alle A records die op de nameserver ingesteld staan. Bovenin wordt je
profiel getoont zoals gekregen van google en opgeslagen in de database.

Met de knop "Query JWT" kan je de JWT opvragen die google mee heeft gegeven met het inloggen, deze JWT kan je gebruiken om de API handmatig met curl aan te roepen en
is verplicht.

Met de Add SUB form kan je een gebruiker authorizeren om in laten te loggen. Als een gebruikter niet mag inloggen wordt
tijdens het inloggen een error getoont met een 21 cijferig code. Die code moet in de Google UUID box worden ingevoerd
om de desbetreffende gebruiker authorizatie te geven om in te kunnen loggen.

De tabel met DNS records spreekt voorzich. Alle bestaande records worden weergeven en de adressen zijn aanpasbaar.
Wanneer er een adres aangepast moet worden is dat makkelijk te doen door de waarde aan te wijzigen en Update aan te
klikken. Evendeels is het verwijderen van een record ook mogelijk door op Delete te klikken.

Een nieuwe record kan worden toegevoegd door de subdomain aan te geven met de juiste IPv4 Waarde. Momenteel zijn alleen
A records ondersteund. Klik op Add om de record toe te voegen.

![dashboard page](.assets/dashboard.png)